/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _ADMPROTO_H_RPCGEN
#define _ADMPROTO_H_RPCGEN

#include <rpc/rpc.h>


enum cfsstat {
	CFS_OK = 0,
	CFSERR_PERM = 1,
	CFSERR_IFULL = 2,
	CFSERR_NOINS = 3,
	CFSERR_EXIST = 4,
	CFSERR_NODIR = 5,
	CFSERR_BADKEY = 6,
	CFSERR_BADNAME = 7,
};
typedef enum cfsstat cfsstat;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfsstat(XDR *, cfsstat*);
#elif __STDC__ 
extern  bool_t xdr_cfsstat(XDR *, cfsstat*);
#else /* Old Style C */ 
bool_t xdr_cfsstat();
#endif /* Old Style C */ 


enum ciphers {
	CFS_STD_DES = 0,
	CFS_THREE_DES = 1,
	CFS_IDEA = 2,
	CFS_BLOWFISH = 3,
	CFS_SKIPJACK = 4,
};
typedef enum ciphers ciphers;
#ifdef __cplusplus 
extern "C" bool_t xdr_ciphers(XDR *, ciphers*);
#elif __STDC__ 
extern  bool_t xdr_ciphers(XDR *, ciphers*);
#else /* Old Style C */ 
bool_t xdr_ciphers();
#endif /* Old Style C */ 

#define CFS_MAXCOMP 255
#define CFS_MAXNAME 1024

struct cfs_adm_deskey {
	long pl;
	u_char primary[8];
	u_char secondary[8];
};
typedef struct cfs_adm_deskey cfs_adm_deskey;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_adm_deskey(XDR *, cfs_adm_deskey*);
#elif __STDC__ 
extern  bool_t xdr_cfs_adm_deskey(XDR *, cfs_adm_deskey*);
#else /* Old Style C */ 
bool_t xdr_cfs_adm_deskey();
#endif /* Old Style C */ 


struct cfs_adm_3deskey {
	long pl;
	u_char primary1[8];
	u_char primary2[8];
	u_char secondary1[8];
	u_char secondary2[8];
};
typedef struct cfs_adm_3deskey cfs_adm_3deskey;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_adm_3deskey(XDR *, cfs_adm_3deskey*);
#elif __STDC__ 
extern  bool_t xdr_cfs_adm_3deskey(XDR *, cfs_adm_3deskey*);
#else /* Old Style C */ 
bool_t xdr_cfs_adm_3deskey();
#endif /* Old Style C */ 


struct cfs_admkey {
	ciphers cipher;
	union {
		cfs_adm_deskey deskey;
		cfs_adm_3deskey des3key;
	} cfs_admkey_u;
};
typedef struct cfs_admkey cfs_admkey;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_admkey(XDR *, cfs_admkey*);
#elif __STDC__ 
extern  bool_t xdr_cfs_admkey(XDR *, cfs_admkey*);
#else /* Old Style C */ 
bool_t xdr_cfs_admkey();
#endif /* Old Style C */ 


struct cfs_attachargs {
	char *dirname;
	char *name;
	cfs_admkey key;
	int uid;
	int highsec;
	bool_t anon;
	int expire;
};
typedef struct cfs_attachargs cfs_attachargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_attachargs(XDR *, cfs_attachargs*);
#elif __STDC__ 
extern  bool_t xdr_cfs_attachargs(XDR *, cfs_attachargs*);
#else /* Old Style C */ 
bool_t xdr_cfs_attachargs();
#endif /* Old Style C */ 


struct cfs_detachargs {
	char *name;
	int uid;
};
typedef struct cfs_detachargs cfs_detachargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_detachargs(XDR *, cfs_detachargs*);
#elif __STDC__ 
extern  bool_t xdr_cfs_detachargs(XDR *, cfs_detachargs*);
#else /* Old Style C */ 
bool_t xdr_cfs_detachargs();
#endif /* Old Style C */ 


struct cfs_lsargs {
	int cookie;
};
typedef struct cfs_lsargs cfs_lsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_lsargs(XDR *, cfs_lsargs*);
#elif __STDC__ 
extern  bool_t xdr_cfs_lsargs(XDR *, cfs_lsargs*);
#else /* Old Style C */ 
bool_t xdr_cfs_lsargs();
#endif /* Old Style C */ 


struct lsok {
	char *dirname;
	int owner;
	int iid;
	char *where;
};
typedef struct lsok lsok;
#ifdef __cplusplus 
extern "C" bool_t xdr_lsok(XDR *, lsok*);
#elif __STDC__ 
extern  bool_t xdr_lsok(XDR *, lsok*);
#else /* Old Style C */ 
bool_t xdr_lsok();
#endif /* Old Style C */ 


struct cfs_lsrepl {
	cfsstat status;
	union {
		struct lsok ok;
	} cfs_lsrepl_u;
};
typedef struct cfs_lsrepl cfs_lsrepl;
#ifdef __cplusplus 
extern "C" bool_t xdr_cfs_lsrepl(XDR *, cfs_lsrepl*);
#elif __STDC__ 
extern  bool_t xdr_cfs_lsrepl(XDR *, cfs_lsrepl*);
#else /* Old Style C */ 
bool_t xdr_cfs_lsrepl();
#endif /* Old Style C */ 


#define ADM_PROGRAM ((u_long)0x21234567)
#define ADM_VERSION ((u_long)1)

#ifdef __cplusplus
#define ADMPROC_NULL ((u_long)0)
extern "C" void * admproc_null_1(void *, CLIENT *);
extern "C" void * admproc_null_1_svc(void *, struct svc_req *);
#define ADMPROC_ATTACH ((u_long)1)
extern "C" cfsstat * admproc_attach_1(cfs_attachargs *, CLIENT *);
extern "C" cfsstat * admproc_attach_1_svc(cfs_attachargs *, struct svc_req *);
#define ADMPROC_DETACH ((u_long)2)
extern "C" cfsstat * admproc_detach_1(cfs_detachargs *, CLIENT *);
extern "C" cfsstat * admproc_detach_1_svc(cfs_detachargs *, struct svc_req *);
#define ADMPROC_LS ((u_long)3)
extern "C" cfs_lsrepl * admproc_ls_1(cfs_lsargs *, CLIENT *);
extern "C" cfs_lsrepl * admproc_ls_1_svc(cfs_lsargs *, struct svc_req *);

#elif __STDC__
#define ADMPROC_NULL ((u_long)0)
extern  void * admproc_null_1(void *, CLIENT *);
extern  void * admproc_null_1_svc(void *, struct svc_req *);
#define ADMPROC_ATTACH ((u_long)1)
extern  cfsstat * admproc_attach_1(cfs_attachargs *, CLIENT *);
extern  cfsstat * admproc_attach_1_svc(cfs_attachargs *, struct svc_req *);
#define ADMPROC_DETACH ((u_long)2)
extern  cfsstat * admproc_detach_1(cfs_detachargs *, CLIENT *);
extern  cfsstat * admproc_detach_1_svc(cfs_detachargs *, struct svc_req *);
#define ADMPROC_LS ((u_long)3)
extern  cfs_lsrepl * admproc_ls_1(cfs_lsargs *, CLIENT *);
extern  cfs_lsrepl * admproc_ls_1_svc(cfs_lsargs *, struct svc_req *);

#else /* Old Style C */ 
#define ADMPROC_NULL ((u_long)0)
extern  void * admproc_null_1();
extern  void * admproc_null_1_svc();
#define ADMPROC_ATTACH ((u_long)1)
extern  cfsstat * admproc_attach_1();
extern  cfsstat * admproc_attach_1_svc();
#define ADMPROC_DETACH ((u_long)2)
extern  cfsstat * admproc_detach_1();
extern  cfsstat * admproc_detach_1_svc();
#define ADMPROC_LS ((u_long)3)
extern  cfs_lsrepl * admproc_ls_1();
extern  cfs_lsrepl * admproc_ls_1_svc();
#endif /* Old Style C */ 

#endif /* !_ADMPROTO_H_RPCGEN */
